#!/bin/sh
#
# $Id: @(#)14  1.6 src/pdwebsms/service/smsbackup.sh.src, pdwebsms.serviceability, amwebsms600, 050901a 05/08/31 21:40:37 @(#) $
#
# Component Name: pdwebsms.serviceability
#
# File Name: smsservicelevel.sh
#
# Licensed Materials - Property of IBM
# 5724-C0814
# (c) Copyright International Business Machines Corp. 2005
# All Rights Reserved
# US Government Users Restricted Rights - Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.

bindir=`dirname $0`
smshome=`cd "${bindir}/.."; pwd`
smscfgjar="${smshome}/lib/smscfg.jar"
messagesjar="${smshome}/nls/java/messages.jar"
classpath="${messagesjar}:${smscfgjar}"

localMode=""
wsadminOptionCount=0
commandOptionCount=0

set -- -command "`basename $0`" "${@}"
while [ -n "$1" ]; do
    if [ "$1" = "-local" ]; then
	localMode="1"
    elif [ "$1" = "-was_home" ]; then
	wasHomeOption="1"
    elif [ "$1" = "-wsadmin_options" ]; then
	wsadminOptions="1"
    elif [ "$1" = "--" ]; then
	wsadminOptions=""
    elif [ -n "$wasHomeOption" ]; then
	WAS_HOME="$1"
	wasHomeOption=""
    elif [ -n "$wsadminOptions" ]; then
	wsadminOption[$wsadminOptionCount]="$1"
	wsadminOptionCount=$(($wsadminOptionCount + 1))
    else
	#
	# We set the command options for wsadmin as Java system properties.
	# This is done for two reasons. The first is that wsadmin
	# warns about any arguments it doesn't recognized - annoying.
	# The second is that we can't access strings in JACL that
	# contain backslashes.
	#
	case "$1" in
	    -help|-usage|-?)
	        wsadminOption[$wsadminOptionCount]=-javaoption
		wsadminOptionCount=$(($wsadminOptionCount + 1))
		wsadminOption[$wsadminOptionCount]=-Dsmsbackup.-help=true
		wsadminOptionCount=$(($wsadminOptionCount + 1))

		commandOption[$commandOptionCount]="-usage"
		commandOptionCount=$(($commandOptionCount + 1))
		;;
	    
	    -path|-list|-command)
		wsadminOption[$wsadminOptionCount]=-javaoption
		wsadminOptionCount=$(($wsadminOptionCount + 1))
		wsadminOption[$wsadminOptionCount]="-Dsmsbackup.$1=${2:---missing--}"
		wsadminOptionCount=$(($wsadminOptionCount + 1))

		commandOption[$commandOptionCount]="$1"
		commandOptionCount=$(($commandOptionCount + 1))
		if [ -n "$2" ]; then
		    commandOption[$commandOptionCount]="$2"
		    commandOptionCount=$(($commandOptionCount + 1))
		fi

		shift
		;;
	    *)
		wsadminOption[$wsadminOptionCount]="-Dsmsbackup.-unknown=$1"
		wsadminOptionCount=$(($wsadminOptionCount + 1))

		commandOption[$commandOptionCount]="$1"
		commandOptionCount=$(($commandOptionCount + 1))
		;;
	esac
    fi
    shift
done

if [ -z "$WAS_HOME" ]; then
    #
    # We're not internationalized here because we have no way of
    # locating a localized message without knowing WAS_HOME. The usage
    # message should be simple enough to encourage someone to specify
    # the -was_home option after which any misuse of the command line
    # will trigger the display of a full, localised, usage message.
    #
    echo Usage: smsbackup.sh -was_home WAS_HOME
    exit 1
fi
    
if [ -z "$WAS_USER_SCRIPT" -a -r "$WAS_HOME/properties/fsdb/_was_profile_default/default.sh" ]; then
    . "$WAS_HOME/properties/fsdb/_was_profile_default/default.sh"
fi
if [ -n "$WAS_USER_SCRIPT" -a -r "$WAS_USER_SCRIPT" ]; then
. "$WAS_USER_SCRIPT"
fi

#
# 
if [ -n "$localMode" -o \! -r "$bindir/smsbackup.jacl" ]; then
    extrawasjars="${WAS_HOME}/lib/management.jar:${WAS_HOME}/lib/admin.jar"
    commandOption[$commandOptionCount]="-was_home"
    commandOptionCount=$(($commandOptionCount + 1))
    commandOption[$commandOptionCount]="$WAS_HOME"
    commandOptionCount=$(($commandOptionCount + 1))
    java -classpath "${classpath}:${WAS_CLASSPATH}:${extrawasjars}" com.tivoli.am.sms.service.Backup "${commandOption[@]}"
else
    wsadminOption[$wsadminOptionCount]="-javaoption"
    wsadminOptionCount=$(($wsadminOptionCount + 1))
    wsadminOption[$wsadminOptionCount]="-Dsmsbackup.-home=${smshome}"
    wsadminOptionCount=$(($wsadminOptionCount + 1))
    wsadminOption[$wsadminOptionCount]="-javaoption"
    wsadminOptionCount=$(($wsadminOptionCount + 1))
    wsadminOption[$wsadminOptionCount]="-Dsmsbackup.-temp=${TMPDIR:-/tmp}"
    wsadminOptionCount=$(($wsadminOptionCount + 1))
    "$WAS_HOME/bin/wsadmin.sh" "${wsadminOption[@]}" -wsadmin_classpath "${classpath}" -f "$bindir/smsbackup.jacl"
fi
