#!/bin/sh
#
# $Id: @(#)98  1.6 src/pdwebsms/config/cars/smscars.sh.src, pdwebsms.instcfg, amwebsms600, 050708a 05/06/26 19:20:50 @(#) $
#
# Component Name: pdwebsms.instcfg
#
# File Name: smscars.sh
#
# Licensed Materials - Property of IBM
# 5724-C0814
# (c) Copyright International Business Machines Corp. 2005
# All Rights Reserved
# US Government Users Restricted Rights - Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.

wasHomeOption=""
wsadminOptionCount=1

set -- -command smscars.sh "${@}"
while [ -n "$1" ]; do
    if [ "$1" = "-was_home" ]; then
	wasHomeOption="1"
    elif [ "$1" = "-wsadmin_options" ]; then
	wsadminOptions="1"
    elif [ "$1" = "--" ]; then
	wsadminOptions=""
    elif [ -n "$wasHomeOption" ]; then
	WAS_HOME="$1"
	wasHomeOption=""
    elif [ -n "$wsadminOptions" ]; then
	wsadminOption[$wsadminOptionCount]="$1"
	wsadminOptionCount=$(($wsadminOptionCount + 1))
    else
	#
	# We set the command options as Java system properties.
	# This is done for two reasons. The first is that wsadmin
	# warns about any arguments it doesn't recognized - annoying.
	# The second is that we can't access strings in JACL that
	# contain backslashes.
	#
	case "$1" in
	    -help|-usage|-?)
	        wsadminOption[$wsadminOptionCount]=-javaoption
		wsadminOptionCount=$(($wsadminOptionCount + 1))
		wsadminOption[$wsadminOptionCount]=-Dsmscars.-help=true
		wsadminOptionCount=$(($wsadminOptionCount + 1))
		;;
	    
	    -noenable|-norestart|-nodescope)
	        wsadminOption[$wsadminOptionCount]=-javaoption
		wsadminOptionCount=$(($wsadminOptionCount + 1))
		wsadminOption[$wsadminOptionCount]=-Dsmscars.$1=true
		wsadminOptionCount=$(($wsadminOptionCount + 1))
		;;
	    
	    -cars|-name|-server|-action|-command)
		wsadminOption[$wsadminOptionCount]=-javaoption
		wsadminOptionCount=$(($wsadminOptionCount + 1))
		wsadminOption[$wsadminOptionCount]="-Dsmscars.$1=${2:---missing--}"
		wsadminOptionCount=$(($wsadminOptionCount + 1))
		shift
		;;
	    *)
		wsadminOption[$wsadminOptionCount]="-Dsmscars.-unknown=$1"
		wsadminOptionCount=$(($wsadminOptionCount + 1))
		;;
	esac
    fi
    shift
done

#
# We need to specify a value for -wsadmin_classpath so that
# our script can locate it's message resource files.
#
# We look first for translated messages in <install-dir>/nls/java/messages.jar
# and then for default messages in <install-dir>/bin/smscfg.jar
#
bindir=`dirname "$0"`
smshome=`cd "${bindir}/.."; pwd`
smscfgjar="${smshome}/lib/smscfg.jar"
messagesjar="${smshome}/nls/java/messages.jar"
msgclasspath="${messagesjar}:${smscfgjar}"

if [ -z "$WAS_HOME" ]; then
    #
    # We're not internationalized here because we have no way of
    # locating a localized message without knowing WAS_HOME. The usage
    # message should be simple enough to encourage someone to specify
    # the -was_home option after which any misuse of the command line
    # will trigger the display of a full, localised, usage message.
    #
    if which java >&- 2>&- ; then
	java -classpath "${msgclasspath}" \
	    com.tivoli.am.sms.nls.PrintMessage \
	    com.tivoli.am.sms.nls.pdwsdidx \
	    dsess_m_wpm_need_was_home
    else
	# Best we can do
	echo "Usage: smscars.sh -was_home <WAS_HOME> -action <ACTION>"
    fi
    exit 1
fi

wsadmin="$WAS_HOME/bin/wsadmin.sh"

"$wsadmin" "${wsadminOption[@]}" -wsadmin_classpath "${msgclasspath}" -f "$bindir/smscars.jacl"
